Codeforces 768D Jon and Orbs (DP)

来源:互联网 发布:11对战平台 mac版 编辑:程序博客网 时间:2024/05/29 16:35


D. Jon and Orbs
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

Jon Snow is on the lookout for some orbs required to defeat the white walkers. There are k different types of orbs and he needs at least one of each. One orb spawns daily at the base of a Weirwood tree north of the wall. The probability of this orb being of any kind is equal. As the north of wall is full of dangers, he wants to know the minimum number of days he should wait before sending a ranger to collect the orbs such that the probability of him getting at least one of each kind of orb is at least , where ε < 10 - 7.

To better prepare himself, he wants to know the answer for q different values of pi. Since he is busy designing the battle strategy with Sam, he asks you for your help.

Input

First line consists of two space separated integers kq (1 ≤ k, q ≤ 1000) — number of different kinds of orbs and number of queries respectively.

Each of the next q lines contain a single integer pi (1 ≤ pi ≤ 1000) — i-th query.

Output

Output q lines. On i-th of them output single integer — answer for i-th query.

Examples
input
1 11
output
1
input
2 212
output
22


【题意】

k种宝石,q个查询,   每天从k种宝石里产生一种, 问 第几天 产生宝石的概率 满足  pi-e/2000 


【思路】

产生宝石  第x 天 产生宝石两种  一种 前面没有出现过, 第一次出现过,  一种是 之前出现过的;

dp【i】【j】 代表 第 i 天 产生 j 种宝石的概率   那么 =  dp【i-1j【j-1】*  (k - (j+1) ) / k  +  dp【i-1】【j】 * j/k

【i-1】【j】 已经出现过, 【i-1】【j-1】 第一次出现;


注意 :   扫描的N 要小于定义的N   因为这个 runtimerror on test 7  7000多就够了其实


【代码实现】 

这样可能耗时, 可以 用数组把答案存下来  大O(1) 查询就可以啦

#include <iostream>#include <bits/stdc++.h>#include <string.h>#include <stdio.h>using namespace std;typedef long long ll;const int N=10515;double dp[N][1005];int main(){    int q,k;    while(~scanf("%d %d",&k,&q))    {        dp[0][0]=1;        for(int i=1;i<=10005;i++)        {            dp[i][0]=0;            for(int j=1;j<=k;j++)            {                dp[i][j]= dp[i-1][j-1]*((k-j+1)/(k*1.0)) + dp[i-1][j]*((j*1.0)/(k*1.0));            }        }        while(q--)        {            int x;            scanf("%d",&x);           // printf("%d\n",ans[x]);           for(int i=1;i<=N;i++)           {               if(dp[i][k]> (double)(x/(2000.0)) )               {                   printf("%d\n",i);                   break;               }           }        }    }    return 0;}


133